----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2021/12/10 18:40:04
-- Design Name: 
-- Module Name: mul_add_3uni - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:3f[^̐ϘaZ
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
--use ieee.std_logic_arith.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mul_add_3uni is
    generic (
        in_int : integer;--p[^:4bit
        in_dec : integer;--p[^:12bit
        w_int : integer;--p[^:4bit
        w_dec : integer --p[^:12bit
    );
    Port (
    --input--
         clk : in STD_LOGIC;
         data_0 : in signed(in_int+in_dec-1 downto 0);
         data_1 : in signed(in_int+in_dec-1 downto 0);
         data_2 : in signed(in_int+in_dec-1 downto 0);
         w_0 : in signed(w_int+w_dec-1 downto 0);
         w_1 : in signed(w_int+w_dec-1 downto 0);
         w_2 : in signed(w_int+w_dec-1 downto 0);
    --output--
         mul_add : out signed((in_int+in_dec)+(w_int+w_dec) - 1 downto 0) --SvZŌJオ肵Ȃz
    );
end mul_add_3uni;

architecture Behavioral of mul_add_3uni is
    constant out_len : integer :=(in_int+in_dec)+(w_int+w_dec);
    signal temp_0, temp_1, temp_2 : signed(out_len-1 downto 0) := (others => '0');
begin
    process(clk)--dݏZ~3
    begin
        if (clk'event and clk='1') then
            temp_0 <= data_0 * w_0;
            temp_1 <= data_1 * w_1;
            temp_2 <= data_2 * w_2;
        end if;
    end process;

    process(clk)--Z
    begin
        if (clk'event and clk='1') then
            mul_add <= temp_0 + temp_1 + temp_2;--resize2bitg
        end if;
    end process;
end Behavioral;
