----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 2021/12/10 23:00:15
-- Design Name: 
-- Module Name: add_4_data - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:add 4 data
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity add_3_data is
    generic (
        data_len : integer
    );
    Port (
    --input--
        clk : in STD_LOGIC;
        data_0 : in signed(data_len -1 downto 0) := (others => '0');
        data_1 : in signed(data_len -1 downto 0) := (others => '0');
        data_2 : in signed(data_len -1 downto 0) := (others => '0');
    --output--
        add_out : out signed(data_len -1 downto 0)
    );
end add_3_data;

architecture Behavioral of add_3_data is
    
    signal temp_0 : signed(data_len -1 downto 0) := (others => '0');
begin
    
    process(clk)
    begin
        if (clk'event and clk='1') then
            temp_0 <= data_0 + data_1 + data_2; --ZɂJオ肪Ȃz
        end if;
    end process;
    
    add_out <= temp_0;  


end Behavioral;