`timescale 1ns / 1ps //P/x

import axi_vip_pkg::*;
import design_2_axi_vip_0_0_pkg::*;


 module tb_axi();

    // KȒlݒ
    parameter STEP = 8;

    parameter INDATASIZE=512 * 512;
    parameter OUTDATASIZE=256 * 256;

    bit iclk;
    bit irstn =1;
    bit [29:0] dout;
    bit [17:0] counter=0;
    bit [20:0] i,j;
    bit rready,rvalid;
    bit [31:0] rdata;
    int fileHandle;
    
    //sim_design_wrapper dut(.*);
    // DUT instance
    //logic aresetn, aclk;
    //logic axi_init;
    wire irq;
   
    
    
//    design_1_wrapper dut(
//     .aclk(iclk),
//    .irstn(irstn),
//    .s00_axi_rdata_0(rdata), 
//    .s00_axi_rvalid_0(rvalid));

  design_2 design_2(
    .iclk(iclk),
    .ireset(irstn));
    
//     design_3 design_3(
//    .aclk(iclk),
//    .irstn(irstn));
    //.s00_axi_rdata_0(rdata), 
    //.s00_axi_rvalid_0(rvalid));

    // NbN
    task clk_gen();
        iclk = 0;
        forever #(STEP/2) iclk = ~iclk;
    endtask

    //NbN
    default clocking cb@(posedge iclk);
    endclocking
    
    // ZbgM   
    task rst_gen();
        irstn = 0;
        #(STEP*10);
        irstn = 1;
    endtask
    

    // agenttransaction錾
    design_2_axi_vip_0_0_mst_t vip_agent;   //}X^[VIPG[WFg̐錾
    axi_transaction wr_transaction, rd_transaction;
    
    initial begin
    // Init AXI agent
        vip_agent = new("my vip agent", tb_axi.design_2.axi_vip_0.inst.IF);
        vip_agent.start_master(); //G[WFg̊Jn
    end
    
    task write_tr(input integer  addr,  input bit [32:0] data);
        wr_transaction = vip_agent.wr_driver.create_transaction("write transaction");
        //wr_transaction.set_write_cmd(addr, XIL_AXI_BURST_TYPE_INCR, 0, 0, xil_axi_size_t'(xil_clog2((32)/8)));
        wr_transaction.set_write_cmd(addr, XIL_AXI_BURST_TYPE_INCR, 0, 0, xil_axi_size_t'(xil_clog2((32)/8)));
        wr_transaction.set_data_block(data);
        vip_agent.wr_driver.send(wr_transaction);
    endtask
    
    task read_tr(input integer addr);
         rd_transaction = vip_agent.rd_driver.create_transaction("read transaxtion");
         rd_transaction.set_read_cmd(addr, XIL_AXI_BURST_TYPE_INCR, 0, 0,xil_axi_size_t'(xil_clog2((32)/8)));
         vip_agent.rd_driver.send(rd_transaction);
     endtask
         
    

    initial  begin
        fork
            clk_gen();
            rst_gen();
        join_none

       repeat(25) @(posedge iclk);//nmatsu
       
        
//        for (i=0; i < INDATASIZE  ; i=i+1) begin     
//            write_tr( 4* i, dout);   
//            repeat(7) @(posedge iclk);
//            counter = counter + 1;
//            repeat(3) @(posedge iclk);
//        end
        //nz
//        write_tr(INDATASIZE * 4,0);
//        repeat(7) @(posedge iclk);
        //zparam_init
        //write_tr(16385 * 4,32'h00fae338);
        write_tr((30) * 4,32'd393352);
        repeat(10) @(posedge iclk);
        write_tr((31) * 4,32'd545564);
        repeat(10) @(posedge iclk);
        write_tr((32) * 4,32'd201396490);
        repeat(10) @(posedge iclk);
        write_tr((33) * 4,32'd417876630);
        repeat(10) @(posedge iclk);
        //zparam_delta
//        write_tr((INDATASIZE + 2) * 4,0);
//        repeat(7) @(posedge iclk);
//        write_tr((INDATASIZE + 3) * 4,32'hff000000);
//        repeat(7) @(posedge iclk);
         
        
        
         repeat(22600) @(posedge iclk);//

         for (i=0; i <55 ; i=i+1) begin     
            read_tr(i * 4);
            repeat(10) @(posedge iclk);
         end 
         
       repeat(30) @(posedge iclk);
        $finish;
    end
      
           

endmodule